import processing.sound.*;

import processing.video.*;

int nx=50;
int ny=35;

int tx,ty;

TriOsc triOsc;
Env env; 

// Times and levels for the ASR envelope
float attackTime = 0.001;
float sustainTime = 0.004;
float sustainLevel = 0.3;
float releaseTime = 0.2;


int duration = 200;

int trigger;

//
// ! ! ! ! !
// changer les parametres ici 
String s="Sea Cucumber.txt";
String PATH ="Sea Cucumber.mp4";
Movie mov;

texte montexte;

void setup() {
  size(550,360);
  montexte=new texte(s);
  textAlign(CENTER);
  mov = new Movie(this, PATH);
  mov.play();
  mov.speed(1);
  mov.volume(0);
 

  println("nombre de mots dans le texte : "+montexte.nombre_mots);
  println("nombre de phrases dans le texte : "+montexte.nombre_phrases);
  println("nombre de mots dans l'inventaire : "+montexte.inventaire.size());

  triOsc = new TriOsc(this);

  // Create the envelope 
  env  = new Env(this); 
  //out.pauseNotes();
  trigger = millis();
  noStroke();
}

void draw() {
  //image(mov, 0, 0, width, height);
   tx=mov.width/nx;
  ty=mov.height/ny;
  
  for (int x = 0; x < mov.width; x+=tx) {
      for (int y = 0; y < mov.height; y+=ty) {
        fill(mov.get(int(x), int(y)));
        rect(x,y,tx,ty);
      }
    }
  
  
  
  
  if (millis() > trigger) {
    text(montexte.mot, width/2, height*0.2);


    triOsc.play(midiToFreq(60-montexte.mot.length()), 0.8);

    // The envelope gets triggered with the oscillator as input and the times and levels we defined earlier
    env.play(triOsc, attackTime, sustainTime, sustainLevel, releaseTime);



    montexte.mot_suivant();

    // Create the new trigger according to predefined durations and speed it up by deviding by 1.5
    trigger = millis() + duration;
  }
}

float midiToFreq(int note) {
  return (pow(2, ((note-69)/12.0)))*440;
}

void movieEvent(Movie m) {
  m.read();
}